\begin{algorithm}
\caption{Dissemination inspired by a lamport clock with buffer management}
\begin{algorithmic}[1]
  \State $k\gets ...$ \Comment{Fanout}
  \State $maxrank\gets ...$ \Comment{Ideal generation size}
  \State $n\gets ...$ \Comment{Max gen.}
  \State $g\gets -1$ \Comment{Generation number}
  \item[]

  \State $rcv\gets \varnothing$ \Comment{Received packets}
  \State $dlv\gets \varnothing$ \Comment{Delivered complete packets}
  \item[]

  \Function{NextGen}{h}
    \While{$(h < g + n \div 2 \pmod{n} < g)
            \lor (g < h < g + n \div 2)
            \lor (\Call{Rank}{g, rcv} \geq maxrank)$}
      \State $g \gets g + 1 \pmod{n}$
      \ForAll{$\langle i,c,e \rangle \in recv, i = g + n \div 2 \pmod{n}$}
        \State $rcv \gets rcv \setminus \{ \langle i,c,e \rangle \}$
        \State $dlv \gets dlv \setminus \{ \langle i,c,e \rangle \}$
      \EndFor \Comment{Garbage Collection}
    \EndWhile
  \EndFunction
  \item[]

  \Function{Disseminate}{h}
    \For{$k$ times}
      \State $p \gets \Call{Recode}{h, rcv} $
      \State $\Call{Send}{p}$
    \EndFor
  \EndFunction
  \item[]

  \Function{Broadcast}{e}
    \State \Call{Wait}{g} \Comment{Wait for $g \geq 0$}
    \State $p\gets \langle g, \{ \Call{UniqueID}{ }: 1 \}, e \rangle$
    \State $rcv \gets rcv \cup \{ p \}$
    \State $dlv \gets dlv \cup \{ p \}$
    \State $\Call{Disseminate}{g}$
    \State $\Call{NextGen}{g}$
  \EndFunction
  \item[]

  \Function{Receive}{p}
    \State $ \langle h, \_, \_ \rangle \gets p$
    \State $\Call{NextGen}{h}$
    \item[]

    \State $ oldRank \gets \Call{Rank}{h, rcv}$
    \State $rcv \gets \Call{Decode}{h, rcv \cup \{ p \}} $

    \If{$oldRank < \Call{Rank}{h, rcv}$} 
      \State $\Call{Disseminate}{h}$
    \EndIf \Comment If new information in the matrix
    \item[]

    \ForAll{$q \in rcv \setminus dlv$}
      \State $\langle i, c, e \rangle \gets q$
      \If{$i = h \land c$ match $\{\_: 1\}$}
        \State $dlv \gets dlv \cup \{ q \}$
        \State $\Call{Deliver}{e}$
      \EndIf \Comment{If decoded a new packet}
    \EndFor

  \EndFunction
\end{algorithmic}
\end{algorithm}


